/* animated-scrolled-window.c generated by valac 0.56.13, the Vala compiler
 * generated from animated-scrolled-window.vala, do not modify */

/* animated-scrolled-window.vala
 *
 * Copyright (C) 2017 Red Hat, Inc.
 * Copyright (C) 2023 Markus Göllnitz
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 *          Markus Göllnitz <camelcasenick@bewares.it>
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>

#define USAGE_ANIMATED_SCROLLED_WINDOW_DURATION ((guint) 400)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define USAGE_TYPE_ANIMATED_SCROLLED_WINDOW (usage_animated_scrolled_window_get_type ())
#define USAGE_ANIMATED_SCROLLED_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_ANIMATED_SCROLLED_WINDOW, UsageAnimatedScrolledWindow))
#define USAGE_ANIMATED_SCROLLED_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_ANIMATED_SCROLLED_WINDOW, UsageAnimatedScrolledWindowClass))
#define USAGE_IS_ANIMATED_SCROLLED_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_ANIMATED_SCROLLED_WINDOW))
#define USAGE_IS_ANIMATED_SCROLLED_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_ANIMATED_SCROLLED_WINDOW))
#define USAGE_ANIMATED_SCROLLED_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_ANIMATED_SCROLLED_WINDOW, UsageAnimatedScrolledWindowClass))

typedef struct _UsageAnimatedScrolledWindow UsageAnimatedScrolledWindow;
typedef struct _UsageAnimatedScrolledWindowClass UsageAnimatedScrolledWindowClass;
typedef struct _UsageAnimatedScrolledWindowPrivate UsageAnimatedScrolledWindowPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _usage_animated_scrolled_window_unref0(var) ((var == NULL) ? NULL : (var = (usage_animated_scrolled_window_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef struct _UsageParamSpecAnimatedScrolledWindow UsageParamSpecAnimatedScrolledWindow;
enum  {
	USAGE_ANIMATED_SCROLLED_WINDOW_SCROLL_CHANGED_SIGNAL,
	USAGE_ANIMATED_SCROLLED_WINDOW_NUM_SIGNALS
};
static guint usage_animated_scrolled_window_signals[USAGE_ANIMATED_SCROLLED_WINDOW_NUM_SIGNALS] = {0};

struct _UsageAnimatedScrolledWindow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UsageAnimatedScrolledWindowPrivate * priv;
};

struct _UsageAnimatedScrolledWindowClass {
	GTypeClass parent_class;
	void (*finalize) (UsageAnimatedScrolledWindow *self);
};

struct _UsageAnimatedScrolledWindowPrivate {
	GtkSettings* gtk_settings;
	GtkScrolledWindow* _scrolled_window;
};

struct _Block1Data {
	int _ref_count_;
	UsageAnimatedScrolledWindow* self;
	GtkScrolledWindow* scrolled_window;
};

struct _Block2Data {
	int _ref_count_;
	UsageAnimatedScrolledWindow* self;
	GdkFrameClock* clock;
	gint64 start_time;
	gint64 end_time;
	gdouble source;
	gdouble target;
	gulong tick_id;
};

struct _UsageParamSpecAnimatedScrolledWindow {
	GParamSpec parent_instance;
};

static gint UsageAnimatedScrolledWindow_private_offset;
static gpointer usage_animated_scrolled_window_parent_class = NULL;

VALA_EXTERN gpointer usage_animated_scrolled_window_ref (gpointer instance);
VALA_EXTERN void usage_animated_scrolled_window_unref (gpointer instance);
VALA_EXTERN GParamSpec* usage_param_spec_animated_scrolled_window (const gchar* name,
                                                       const gchar* nick,
                                                       const gchar* blurb,
                                                       GType object_type,
                                                       GParamFlags flags);
VALA_EXTERN void usage_value_set_animated_scrolled_window (GValue* value,
                                               gpointer v_object);
VALA_EXTERN void usage_value_take_animated_scrolled_window (GValue* value,
                                                gpointer v_object);
VALA_EXTERN gpointer usage_value_get_animated_scrolled_window (const GValue* value);
VALA_EXTERN GType usage_animated_scrolled_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageAnimatedScrolledWindow, usage_animated_scrolled_window_unref)
VALA_EXTERN UsageAnimatedScrolledWindow* usage_animated_scrolled_window_new (GtkScrolledWindow* scrolled_window);
VALA_EXTERN UsageAnimatedScrolledWindow* usage_animated_scrolled_window_construct (GType object_type,
                                                                       GtkScrolledWindow* scrolled_window);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void usage_animated_scrolled_window_set_scrolled_window (UsageAnimatedScrolledWindow* self,
                                                         GtkScrolledWindow* value);
static void __lambda4_ (Block1Data* _data1_);
static void ___lambda4__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                               gpointer self);
VALA_EXTERN void usage_animated_scrolled_window_animated_scroll_vertically (UsageAnimatedScrolledWindow* self,
                                                                gint y);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
VALA_EXTERN GtkScrolledWindow* usage_animated_scrolled_window_get_scrolled_window (UsageAnimatedScrolledWindow* self);
static void __lambda5_ (Block2Data* _data2_);
static gboolean usage_animated_scrolled_window_animate_step (UsageAnimatedScrolledWindow* self,
                                                      gint64 now,
                                                      gint64 start_time,
                                                      gint64 end_time,
                                                      gdouble source,
                                                      gdouble target);
static void ___lambda5__gdk_frame_clock_update (GdkFrameClock* _sender,
                                         gpointer self);
static gdouble usage_animated_scrolled_window_ease_out_cubic (UsageAnimatedScrolledWindow* self,
                                                       gdouble t);
static void usage_animated_scrolled_window_finalize (UsageAnimatedScrolledWindow * obj);
static GType usage_animated_scrolled_window_get_type_once (void);

static inline gpointer
usage_animated_scrolled_window_get_instance_private (UsageAnimatedScrolledWindow* self)
{
	return G_STRUCT_MEMBER_P (self, UsageAnimatedScrolledWindow_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 26 "../src/animated-scrolled-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 161 "animated-scrolled-window.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 32 "../src/animated-scrolled-window.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 32 "../src/animated-scrolled-window.vala"
	return _data1_;
#line 171 "animated-scrolled-window.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 32 "../src/animated-scrolled-window.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 181 "animated-scrolled-window.c"
		UsageAnimatedScrolledWindow* self;
#line 32 "../src/animated-scrolled-window.vala"
		self = _data1_->self;
#line 32 "../src/animated-scrolled-window.vala"
		_g_object_unref0 (_data1_->scrolled_window);
#line 32 "../src/animated-scrolled-window.vala"
		_usage_animated_scrolled_window_unref0 (self);
#line 32 "../src/animated-scrolled-window.vala"
		g_slice_free (Block1Data, _data1_);
#line 191 "animated-scrolled-window.c"
	}
}

static void
__lambda4_ (Block1Data* _data1_)
{
	UsageAnimatedScrolledWindow* self;
	GtkAdjustment* _tmp0_;
#line 34 "../src/animated-scrolled-window.vala"
	self = _data1_->self;
#line 35 "../src/animated-scrolled-window.vala"
	_tmp0_ = gtk_scrolled_window_get_vadjustment (_data1_->scrolled_window);
#line 35 "../src/animated-scrolled-window.vala"
	g_signal_emit (self, usage_animated_scrolled_window_signals[USAGE_ANIMATED_SCROLLED_WINDOW_SCROLL_CHANGED_SIGNAL], 0, gtk_adjustment_get_value (_tmp0_));
#line 206 "animated-scrolled-window.c"
}

static void
___lambda4__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                          gpointer self)
{
#line 34 "../src/animated-scrolled-window.vala"
	__lambda4_ (self);
#line 215 "animated-scrolled-window.c"
}

UsageAnimatedScrolledWindow*
usage_animated_scrolled_window_construct (GType object_type,
                                          GtkScrolledWindow* scrolled_window)
{
	UsageAnimatedScrolledWindow* self = NULL;
	Block1Data* _data1_;
	GtkScrolledWindow* _tmp0_;
	GtkAdjustment* _tmp1_;
#line 32 "../src/animated-scrolled-window.vala"
	g_return_val_if_fail (scrolled_window != NULL, NULL);
#line 32 "../src/animated-scrolled-window.vala"
	self = (UsageAnimatedScrolledWindow*) g_type_create_instance (object_type);
#line 32 "../src/animated-scrolled-window.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 32 "../src/animated-scrolled-window.vala"
	_data1_->_ref_count_ = 1;
#line 32 "../src/animated-scrolled-window.vala"
	_data1_->self = usage_animated_scrolled_window_ref (self);
#line 32 "../src/animated-scrolled-window.vala"
	_tmp0_ = _g_object_ref0 (scrolled_window);
#line 32 "../src/animated-scrolled-window.vala"
	_g_object_unref0 (_data1_->scrolled_window);
#line 32 "../src/animated-scrolled-window.vala"
	_data1_->scrolled_window = _tmp0_;
#line 33 "../src/animated-scrolled-window.vala"
	usage_animated_scrolled_window_set_scrolled_window (self, _data1_->scrolled_window);
#line 34 "../src/animated-scrolled-window.vala"
	_tmp1_ = gtk_scrolled_window_get_vadjustment (_data1_->scrolled_window);
#line 34 "../src/animated-scrolled-window.vala"
	g_signal_connect_data (_tmp1_, "value-changed", (GCallback) ___lambda4__gtk_adjustment_value_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 32 "../src/animated-scrolled-window.vala"
	block1_data_unref (_data1_);
#line 32 "../src/animated-scrolled-window.vala"
	_data1_ = NULL;
#line 32 "../src/animated-scrolled-window.vala"
	return self;
#line 254 "animated-scrolled-window.c"
}

UsageAnimatedScrolledWindow*
usage_animated_scrolled_window_new (GtkScrolledWindow* scrolled_window)
{
#line 32 "../src/animated-scrolled-window.vala"
	return usage_animated_scrolled_window_construct (USAGE_TYPE_ANIMATED_SCROLLED_WINDOW, scrolled_window);
#line 262 "animated-scrolled-window.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 39 "../src/animated-scrolled-window.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 39 "../src/animated-scrolled-window.vala"
	return _data2_;
#line 272 "animated-scrolled-window.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 39 "../src/animated-scrolled-window.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 282 "animated-scrolled-window.c"
		UsageAnimatedScrolledWindow* self;
#line 39 "../src/animated-scrolled-window.vala"
		self = _data2_->self;
#line 39 "../src/animated-scrolled-window.vala"
		_g_object_unref0 (_data2_->clock);
#line 39 "../src/animated-scrolled-window.vala"
		_usage_animated_scrolled_window_unref0 (self);
#line 39 "../src/animated-scrolled-window.vala"
		g_slice_free (Block2Data, _data2_);
#line 292 "animated-scrolled-window.c"
	}
}

static void
__lambda5_ (Block2Data* _data2_)
{
	UsageAnimatedScrolledWindow* self;
	gint64 now = 0LL;
	GdkFrameClock* _tmp0_;
#line 52 "../src/animated-scrolled-window.vala"
	self = _data2_->self;
#line 53 "../src/animated-scrolled-window.vala"
	_tmp0_ = _data2_->clock;
#line 53 "../src/animated-scrolled-window.vala"
	now = gdk_frame_clock_get_frame_time (_tmp0_);
#line 55 "../src/animated-scrolled-window.vala"
	if (!usage_animated_scrolled_window_animate_step (self, now, _data2_->start_time, _data2_->end_time, _data2_->source, _data2_->target)) {
#line 310 "animated-scrolled-window.c"
		GdkFrameClock* _tmp1_;
		GdkFrameClock* _tmp2_;
#line 56 "../src/animated-scrolled-window.vala"
		_tmp1_ = _data2_->clock;
#line 56 "../src/animated-scrolled-window.vala"
		g_signal_handler_disconnect ((GObject*) _tmp1_, _data2_->tick_id);
#line 57 "../src/animated-scrolled-window.vala"
		_data2_->tick_id = (gulong) 0;
#line 58 "../src/animated-scrolled-window.vala"
		_tmp2_ = _data2_->clock;
#line 58 "../src/animated-scrolled-window.vala"
		gdk_frame_clock_end_updating (_tmp2_);
#line 323 "animated-scrolled-window.c"
	}
}

static void
___lambda5__gdk_frame_clock_update (GdkFrameClock* _sender,
                                    gpointer self)
{
#line 52 "../src/animated-scrolled-window.vala"
	__lambda5_ (self);
#line 333 "animated-scrolled-window.c"
}

void
usage_animated_scrolled_window_animated_scroll_vertically (UsageAnimatedScrolledWindow* self,
                                                           gint y)
{
	Block2Data* _data2_;
	GtkSettings* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GtkScrolledWindow* _tmp6_;
	GdkFrameClock* _tmp7_;
	GdkFrameClock* _tmp8_;
	GdkFrameClock* _tmp9_;
	GtkScrolledWindow* _tmp10_;
	GtkAdjustment* _tmp11_;
	GtkAdjustment* _tmp12_;
	GdkFrameClock* _tmp13_;
	gulong _tmp14_;
	GdkFrameClock* _tmp15_;
#line 39 "../src/animated-scrolled-window.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/animated-scrolled-window.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 39 "../src/animated-scrolled-window.vala"
	_data2_->_ref_count_ = 1;
#line 39 "../src/animated-scrolled-window.vala"
	_data2_->self = usage_animated_scrolled_window_ref (self);
#line 40 "../src/animated-scrolled-window.vala"
	_tmp0_ = self->priv->gtk_settings;
#line 40 "../src/animated-scrolled-window.vala"
	g_object_get (_tmp0_, "gtk-enable-animations", &_tmp1_, NULL);
#line 40 "../src/animated-scrolled-window.vala"
	_tmp2_ = _tmp1_;
#line 40 "../src/animated-scrolled-window.vala"
	if (!_tmp2_) {
#line 370 "animated-scrolled-window.c"
		GtkScrolledWindow* _tmp3_;
		GtkAdjustment* _tmp4_;
		GtkAdjustment* _tmp5_;
#line 41 "../src/animated-scrolled-window.vala"
		_tmp3_ = self->priv->_scrolled_window;
#line 41 "../src/animated-scrolled-window.vala"
		_tmp4_ = gtk_scrolled_window_get_vadjustment (_tmp3_);
#line 41 "../src/animated-scrolled-window.vala"
		_tmp5_ = _tmp4_;
#line 41 "../src/animated-scrolled-window.vala"
		gtk_adjustment_set_value (_tmp5_, (gdouble) y);
#line 42 "../src/animated-scrolled-window.vala"
		block2_data_unref (_data2_);
#line 42 "../src/animated-scrolled-window.vala"
		_data2_ = NULL;
#line 42 "../src/animated-scrolled-window.vala"
		return;
#line 388 "animated-scrolled-window.c"
	}
#line 45 "../src/animated-scrolled-window.vala"
	_tmp6_ = self->priv->_scrolled_window;
#line 45 "../src/animated-scrolled-window.vala"
	_tmp7_ = gtk_widget_get_frame_clock ((GtkWidget*) _tmp6_);
#line 45 "../src/animated-scrolled-window.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 45 "../src/animated-scrolled-window.vala"
	_data2_->clock = _tmp8_;
#line 46 "../src/animated-scrolled-window.vala"
	_tmp9_ = _data2_->clock;
#line 46 "../src/animated-scrolled-window.vala"
	_data2_->start_time = gdk_frame_clock_get_frame_time (_tmp9_);
#line 47 "../src/animated-scrolled-window.vala"
	_data2_->end_time = _data2_->start_time + (1000 * USAGE_ANIMATED_SCROLLED_WINDOW_DURATION);
#line 48 "../src/animated-scrolled-window.vala"
	_tmp10_ = self->priv->_scrolled_window;
#line 48 "../src/animated-scrolled-window.vala"
	_tmp11_ = gtk_scrolled_window_get_vadjustment (_tmp10_);
#line 48 "../src/animated-scrolled-window.vala"
	_tmp12_ = _tmp11_;
#line 48 "../src/animated-scrolled-window.vala"
	_data2_->source = gtk_adjustment_get_value (_tmp12_);
#line 49 "../src/animated-scrolled-window.vala"
	_data2_->target = (gdouble) y;
#line 50 "../src/animated-scrolled-window.vala"
	_data2_->tick_id = (gulong) 0;
#line 52 "../src/animated-scrolled-window.vala"
	_tmp13_ = _data2_->clock;
#line 52 "../src/animated-scrolled-window.vala"
	_tmp14_ = g_signal_connect_data (_tmp13_, "update", (GCallback) ___lambda5__gdk_frame_clock_update, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 52 "../src/animated-scrolled-window.vala"
	_data2_->tick_id = _tmp14_;
#line 61 "../src/animated-scrolled-window.vala"
	_tmp15_ = _data2_->clock;
#line 61 "../src/animated-scrolled-window.vala"
	gdk_frame_clock_begin_updating (_tmp15_);
#line 39 "../src/animated-scrolled-window.vala"
	block2_data_unref (_data2_);
#line 39 "../src/animated-scrolled-window.vala"
	_data2_ = NULL;
#line 430 "animated-scrolled-window.c"
}

static gboolean
usage_animated_scrolled_window_animate_step (UsageAnimatedScrolledWindow* self,
                                             gint64 now,
                                             gint64 start_time,
                                             gint64 end_time,
                                             gdouble source,
                                             gdouble target)
{
	gboolean result;
#line 64 "../src/animated-scrolled-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 65 "../src/animated-scrolled-window.vala"
	if (now < end_time) {
#line 446 "animated-scrolled-window.c"
		gdouble t = 0.0;
		GtkScrolledWindow* _tmp0_;
		GtkAdjustment* _tmp1_;
		GtkAdjustment* _tmp2_;
#line 66 "../src/animated-scrolled-window.vala"
		t = (now - start_time) / ((gdouble) (end_time - start_time));
#line 67 "../src/animated-scrolled-window.vala"
		t = usage_animated_scrolled_window_ease_out_cubic (self, t);
#line 68 "../src/animated-scrolled-window.vala"
		_tmp0_ = self->priv->_scrolled_window;
#line 68 "../src/animated-scrolled-window.vala"
		_tmp1_ = gtk_scrolled_window_get_vadjustment (_tmp0_);
#line 68 "../src/animated-scrolled-window.vala"
		_tmp2_ = _tmp1_;
#line 68 "../src/animated-scrolled-window.vala"
		gtk_adjustment_set_value (_tmp2_, source + (t * (target - source)));
#line 69 "../src/animated-scrolled-window.vala"
		result = TRUE;
#line 69 "../src/animated-scrolled-window.vala"
		return result;
#line 467 "animated-scrolled-window.c"
	} else {
		GtkScrolledWindow* _tmp3_;
		GtkAdjustment* _tmp4_;
		GtkAdjustment* _tmp5_;
#line 71 "../src/animated-scrolled-window.vala"
		_tmp3_ = self->priv->_scrolled_window;
#line 71 "../src/animated-scrolled-window.vala"
		_tmp4_ = gtk_scrolled_window_get_vadjustment (_tmp3_);
#line 71 "../src/animated-scrolled-window.vala"
		_tmp5_ = _tmp4_;
#line 71 "../src/animated-scrolled-window.vala"
		gtk_adjustment_set_value (_tmp5_, target);
#line 72 "../src/animated-scrolled-window.vala"
		result = FALSE;
#line 72 "../src/animated-scrolled-window.vala"
		return result;
#line 484 "animated-scrolled-window.c"
	}
}

static gdouble
usage_animated_scrolled_window_ease_out_cubic (UsageAnimatedScrolledWindow* self,
                                               gdouble t)
{
	gdouble p = 0.0;
	gdouble result;
#line 76 "../src/animated-scrolled-window.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 77 "../src/animated-scrolled-window.vala"
	p = t - 1;
#line 78 "../src/animated-scrolled-window.vala"
	result = ((p * p) * p) + 1;
#line 78 "../src/animated-scrolled-window.vala"
	return result;
#line 502 "animated-scrolled-window.c"
}

GtkScrolledWindow*
usage_animated_scrolled_window_get_scrolled_window (UsageAnimatedScrolledWindow* self)
{
	GtkScrolledWindow* result;
	GtkScrolledWindow* _tmp0_;
#line 30 "../src/animated-scrolled-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/animated-scrolled-window.vala"
	_tmp0_ = self->priv->_scrolled_window;
#line 30 "../src/animated-scrolled-window.vala"
	result = _tmp0_;
#line 30 "../src/animated-scrolled-window.vala"
	return result;
#line 518 "animated-scrolled-window.c"
}

static void
usage_animated_scrolled_window_set_scrolled_window (UsageAnimatedScrolledWindow* self,
                                                    GtkScrolledWindow* value)
{
	GtkScrolledWindow* _tmp0_;
#line 30 "../src/animated-scrolled-window.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/animated-scrolled-window.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/animated-scrolled-window.vala"
	_g_object_unref0 (self->priv->_scrolled_window);
#line 30 "../src/animated-scrolled-window.vala"
	self->priv->_scrolled_window = _tmp0_;
#line 534 "animated-scrolled-window.c"
}

static void
usage_value_animated_scrolled_window_init (GValue* value)
{
#line 25 "../src/animated-scrolled-window.vala"
	value->data[0].v_pointer = NULL;
#line 542 "animated-scrolled-window.c"
}

static void
usage_value_animated_scrolled_window_free_value (GValue* value)
{
#line 25 "../src/animated-scrolled-window.vala"
	if (value->data[0].v_pointer) {
#line 25 "../src/animated-scrolled-window.vala"
		usage_animated_scrolled_window_unref (value->data[0].v_pointer);
#line 552 "animated-scrolled-window.c"
	}
}

static void
usage_value_animated_scrolled_window_copy_value (const GValue* src_value,
                                                 GValue* dest_value)
{
#line 25 "../src/animated-scrolled-window.vala"
	if (src_value->data[0].v_pointer) {
#line 25 "../src/animated-scrolled-window.vala"
		dest_value->data[0].v_pointer = usage_animated_scrolled_window_ref (src_value->data[0].v_pointer);
#line 564 "animated-scrolled-window.c"
	} else {
#line 25 "../src/animated-scrolled-window.vala"
		dest_value->data[0].v_pointer = NULL;
#line 568 "animated-scrolled-window.c"
	}
}

static gpointer
usage_value_animated_scrolled_window_peek_pointer (const GValue* value)
{
#line 25 "../src/animated-scrolled-window.vala"
	return value->data[0].v_pointer;
#line 577 "animated-scrolled-window.c"
}

static gchar*
usage_value_animated_scrolled_window_collect_value (GValue* value,
                                                    guint n_collect_values,
                                                    GTypeCValue* collect_values,
                                                    guint collect_flags)
{
#line 25 "../src/animated-scrolled-window.vala"
	if (collect_values[0].v_pointer) {
#line 588 "animated-scrolled-window.c"
		UsageAnimatedScrolledWindow * object;
		object = collect_values[0].v_pointer;
#line 25 "../src/animated-scrolled-window.vala"
		if (object->parent_instance.g_class == NULL) {
#line 25 "../src/animated-scrolled-window.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 595 "animated-scrolled-window.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 25 "../src/animated-scrolled-window.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 599 "animated-scrolled-window.c"
		}
#line 25 "../src/animated-scrolled-window.vala"
		value->data[0].v_pointer = usage_animated_scrolled_window_ref (object);
#line 603 "animated-scrolled-window.c"
	} else {
#line 25 "../src/animated-scrolled-window.vala"
		value->data[0].v_pointer = NULL;
#line 607 "animated-scrolled-window.c"
	}
#line 25 "../src/animated-scrolled-window.vala"
	return NULL;
#line 611 "animated-scrolled-window.c"
}

static gchar*
usage_value_animated_scrolled_window_lcopy_value (const GValue* value,
                                                  guint n_collect_values,
                                                  GTypeCValue* collect_values,
                                                  guint collect_flags)
{
	UsageAnimatedScrolledWindow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 25 "../src/animated-scrolled-window.vala"
	if (!object_p) {
#line 25 "../src/animated-scrolled-window.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 626 "animated-scrolled-window.c"
	}
#line 25 "../src/animated-scrolled-window.vala"
	if (!value->data[0].v_pointer) {
#line 25 "../src/animated-scrolled-window.vala"
		*object_p = NULL;
#line 632 "animated-scrolled-window.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 25 "../src/animated-scrolled-window.vala"
		*object_p = value->data[0].v_pointer;
#line 636 "animated-scrolled-window.c"
	} else {
#line 25 "../src/animated-scrolled-window.vala"
		*object_p = usage_animated_scrolled_window_ref (value->data[0].v_pointer);
#line 640 "animated-scrolled-window.c"
	}
#line 25 "../src/animated-scrolled-window.vala"
	return NULL;
#line 644 "animated-scrolled-window.c"
}

GParamSpec*
usage_param_spec_animated_scrolled_window (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags)
{
	UsageParamSpecAnimatedScrolledWindow* spec;
#line 25 "../src/animated-scrolled-window.vala"
	g_return_val_if_fail (g_type_is_a (object_type, USAGE_TYPE_ANIMATED_SCROLLED_WINDOW), NULL);
#line 25 "../src/animated-scrolled-window.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 25 "../src/animated-scrolled-window.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 25 "../src/animated-scrolled-window.vala"
	return G_PARAM_SPEC (spec);
#line 663 "animated-scrolled-window.c"
}

gpointer
usage_value_get_animated_scrolled_window (const GValue* value)
{
#line 25 "../src/animated-scrolled-window.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, USAGE_TYPE_ANIMATED_SCROLLED_WINDOW), NULL);
#line 25 "../src/animated-scrolled-window.vala"
	return value->data[0].v_pointer;
#line 673 "animated-scrolled-window.c"
}

void
usage_value_set_animated_scrolled_window (GValue* value,
                                          gpointer v_object)
{
	UsageAnimatedScrolledWindow * old;
#line 25 "../src/animated-scrolled-window.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, USAGE_TYPE_ANIMATED_SCROLLED_WINDOW));
#line 25 "../src/animated-scrolled-window.vala"
	old = value->data[0].v_pointer;
#line 25 "../src/animated-scrolled-window.vala"
	if (v_object) {
#line 25 "../src/animated-scrolled-window.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, USAGE_TYPE_ANIMATED_SCROLLED_WINDOW));
#line 25 "../src/animated-scrolled-window.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "../src/animated-scrolled-window.vala"
		value->data[0].v_pointer = v_object;
#line 25 "../src/animated-scrolled-window.vala"
		usage_animated_scrolled_window_ref (value->data[0].v_pointer);
#line 695 "animated-scrolled-window.c"
	} else {
#line 25 "../src/animated-scrolled-window.vala"
		value->data[0].v_pointer = NULL;
#line 699 "animated-scrolled-window.c"
	}
#line 25 "../src/animated-scrolled-window.vala"
	if (old) {
#line 25 "../src/animated-scrolled-window.vala"
		usage_animated_scrolled_window_unref (old);
#line 705 "animated-scrolled-window.c"
	}
}

void
usage_value_take_animated_scrolled_window (GValue* value,
                                           gpointer v_object)
{
	UsageAnimatedScrolledWindow * old;
#line 25 "../src/animated-scrolled-window.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, USAGE_TYPE_ANIMATED_SCROLLED_WINDOW));
#line 25 "../src/animated-scrolled-window.vala"
	old = value->data[0].v_pointer;
#line 25 "../src/animated-scrolled-window.vala"
	if (v_object) {
#line 25 "../src/animated-scrolled-window.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, USAGE_TYPE_ANIMATED_SCROLLED_WINDOW));
#line 25 "../src/animated-scrolled-window.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "../src/animated-scrolled-window.vala"
		value->data[0].v_pointer = v_object;
#line 726 "animated-scrolled-window.c"
	} else {
#line 25 "../src/animated-scrolled-window.vala"
		value->data[0].v_pointer = NULL;
#line 730 "animated-scrolled-window.c"
	}
#line 25 "../src/animated-scrolled-window.vala"
	if (old) {
#line 25 "../src/animated-scrolled-window.vala"
		usage_animated_scrolled_window_unref (old);
#line 736 "animated-scrolled-window.c"
	}
}

static void
usage_animated_scrolled_window_class_init (UsageAnimatedScrolledWindowClass * klass,
                                           gpointer klass_data)
{
#line 25 "../src/animated-scrolled-window.vala"
	usage_animated_scrolled_window_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/animated-scrolled-window.vala"
	((UsageAnimatedScrolledWindowClass *) klass)->finalize = usage_animated_scrolled_window_finalize;
#line 25 "../src/animated-scrolled-window.vala"
	g_type_class_adjust_private_offset (klass, &UsageAnimatedScrolledWindow_private_offset);
#line 25 "../src/animated-scrolled-window.vala"
	usage_animated_scrolled_window_signals[USAGE_ANIMATED_SCROLLED_WINDOW_SCROLL_CHANGED_SIGNAL] = g_signal_new ("scroll-changed", USAGE_TYPE_ANIMATED_SCROLLED_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
#line 752 "animated-scrolled-window.c"
}

static void
usage_animated_scrolled_window_instance_init (UsageAnimatedScrolledWindow * self,
                                              gpointer klass)
{
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
#line 25 "../src/animated-scrolled-window.vala"
	self->priv = usage_animated_scrolled_window_get_instance_private (self);
#line 26 "../src/animated-scrolled-window.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 26 "../src/animated-scrolled-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 26 "../src/animated-scrolled-window.vala"
	self->priv->gtk_settings = _tmp1_;
#line 25 "../src/animated-scrolled-window.vala"
	self->ref_count = 1;
#line 771 "animated-scrolled-window.c"
}

static void
usage_animated_scrolled_window_finalize (UsageAnimatedScrolledWindow * obj)
{
	UsageAnimatedScrolledWindow * self;
#line 25 "../src/animated-scrolled-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_ANIMATED_SCROLLED_WINDOW, UsageAnimatedScrolledWindow);
#line 25 "../src/animated-scrolled-window.vala"
	g_signal_handlers_destroy (self);
#line 26 "../src/animated-scrolled-window.vala"
	_g_object_unref0 (self->priv->gtk_settings);
#line 30 "../src/animated-scrolled-window.vala"
	_g_object_unref0 (self->priv->_scrolled_window);
#line 786 "animated-scrolled-window.c"
}

static GType
usage_animated_scrolled_window_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { usage_value_animated_scrolled_window_init, usage_value_animated_scrolled_window_free_value, usage_value_animated_scrolled_window_copy_value, usage_value_animated_scrolled_window_peek_pointer, "p", usage_value_animated_scrolled_window_collect_value, "p", usage_value_animated_scrolled_window_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (UsageAnimatedScrolledWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_animated_scrolled_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageAnimatedScrolledWindow), 0, (GInstanceInitFunc) usage_animated_scrolled_window_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType usage_animated_scrolled_window_type_id;
	usage_animated_scrolled_window_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UsageAnimatedScrolledWindow", &g_define_type_info, &g_define_type_fundamental_info, 0);
	UsageAnimatedScrolledWindow_private_offset = g_type_add_instance_private (usage_animated_scrolled_window_type_id, sizeof (UsageAnimatedScrolledWindowPrivate));
	return usage_animated_scrolled_window_type_id;
}

GType
usage_animated_scrolled_window_get_type (void)
{
	static volatile gsize usage_animated_scrolled_window_type_id__once = 0;
	if (g_once_init_enter (&usage_animated_scrolled_window_type_id__once)) {
		GType usage_animated_scrolled_window_type_id;
		usage_animated_scrolled_window_type_id = usage_animated_scrolled_window_get_type_once ();
		g_once_init_leave (&usage_animated_scrolled_window_type_id__once, usage_animated_scrolled_window_type_id);
	}
	return usage_animated_scrolled_window_type_id__once;
}

gpointer
usage_animated_scrolled_window_ref (gpointer instance)
{
	UsageAnimatedScrolledWindow * self;
	self = instance;
#line 25 "../src/animated-scrolled-window.vala"
	g_atomic_int_inc (&self->ref_count);
#line 25 "../src/animated-scrolled-window.vala"
	return instance;
#line 822 "animated-scrolled-window.c"
}

void
usage_animated_scrolled_window_unref (gpointer instance)
{
	UsageAnimatedScrolledWindow * self;
	self = instance;
#line 25 "../src/animated-scrolled-window.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 25 "../src/animated-scrolled-window.vala"
		USAGE_ANIMATED_SCROLLED_WINDOW_GET_CLASS (self)->finalize (self);
#line 25 "../src/animated-scrolled-window.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 836 "animated-scrolled-window.c"
	}
}

